    PROGRAM nag_lin_lsq_ex03

      ! Example Program Text for nag_lin_lsq
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_in, nag_std_out
      USE nag_lin_lsq, ONLY : nag_qr_fac, nag_lin_lsq_sol_qr, &
       nag_lin_lsq_sol_qr_svd
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Intrinsic Functions ..
      INTRINSIC KIND, MIN
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)
      ! .. Local Scalars ..
      INTEGER :: i, m, n, ns, rank
      REAL (wp) :: rcond, std_err, tol
      ! .. Local Arrays ..
      INTEGER, ALLOCATABLE :: pivot(:)
      REAL (wp), ALLOCATABLE :: a(:,:), b(:), tau(:), x(:)
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_lin_lsq_ex03'

      READ (nag_std_in,*)          ! Skip heading in data file
      READ (nag_std_in,*) m, n
      ns = MIN(m,n)

      ALLOCATE (pivot(n),a(m,n),b(m),tau(ns),x(n)) ! Allocate storage

      READ (nag_std_in,*) (a(i,:),i=1,m)
      READ (nag_std_in,*) b

      ! Compute the QR factorization

      pivot = 0

      CALL nag_qr_fac(a,tau,pivot=pivot,rcond=rcond)

      tol = 0.005_wp
      WRITE (nag_std_out,*)
      WRITE (nag_std_out,'(1X,2(A,ES11.2))') 'tol =', tol, '  rcond =', rcond
      WRITE (nag_std_out,*)

      IF (rcond>tol) THEN

        ! Compute the solution, assuming that A has full rank,
        ! using the QR factorization

        CALL nag_lin_lsq_sol_qr(a,tau,b,x,pivot=pivot,std_err=std_err)

        WRITE (nag_std_out,*) &
         'Solution from nag_lin_lsq_sol_qr, assuming A has full rank'

      ELSE

        ! Compute the minimum norm solution using the SVD

        CALL nag_lin_lsq_sol_qr_svd(a,tau,b,x,pivot=pivot,tol=tol,rank=rank, &
         std_err=std_err)

        WRITE (nag_std_out,'(1X,A,I7)') &
         'Solution from nag_lin_lsq_sol_qr_svd, assuming A has rank', rank

      END IF

      WRITE (nag_std_out,'(3X,F7.4)') x
      WRITE (nag_std_out,'(1X,A,F7.4)') 'standard error =', std_err

      DEALLOCATE (pivot,a,b,tau,x) ! Deallocate storage

    END PROGRAM nag_lin_lsq_ex03
